function varargout=plotnodes(self,varargin)
  if self.d>3, error('Unable to plot in dimension > 3!');end
  varargin=fc_tools.graphics.xcolor.set_xcolors_varargin(varargin,{'vcolor','ncolor'});  
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
  p.addParamValue('vcolor',self.color); % vertices color
  p.addParamValue('vsize',40); % 
  p.addParamValue('ncolor','k'); % nodes color
  p.addParamValue('nsize',30); % 
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
% d=0 : point
% d=1 : line
% d=2 : square
% d=3 : cube
  h=eval(sprintf('plotnodes%dD(self,R.vcolor,R.vsize,R.ncolor,R.nsize,varargin)',self.d));
  %set(h,'displayname',self.label)
  if nargout==1,varargout{1}=h;end
end

function h=plotnodes3D(self,vColor,vSize,nColor,nSize,PlotOptions)
  if self.order==1
    h=scatter3(self.q(1,:),self.q(2,:),self.q(3,:),vSize,vColor,'filled',PlotOptions{:});
  else
    %if self.type==0
    %  [Idx,cIdx]=fc_hypermesh.VerticesIdxSimpRef(self.m,self.order);
    %else
    %  [Idx,cIdx]=fc_hypermesh.VerticesIdxHypRef(self.m,self.order);
    %end
    n=size(self.me,1);
    cIdx=setdiff(1:n,self.vidx);
    I=unique(reshape(self.me(self.vidx,:),[],1));
    pih=fc_tools.graphics.SetHoldOn(true);
    h1=scatter3(self.q(1,I),self.q(2,I),self.q(3,I),vSize,vColor,'filled',PlotOptions{:});
    I=unique(reshape(self.me(cIdx,:),[],1));
    h2=scatter3(self.q(1,I),self.q(2,I),self.q(3,I),nSize,nColor,'filled',PlotOptions{:});
    fc_tools.graphics.RestoreHold(pih)
    h={h1,h2};
  end
end

function h=plotnodes2D(self,vColor,vSize,nColor,nSize,PlotOptions)
  if self.order==1
    h=scatter(self.q(1,:),self.q(2,:),vSize,vColor,'filled',PlotOptions{:});
  else
    if self.type==0
      [Idx,cIdx]=fc_hypermesh.VerticesIdxSimpRef(self.m,self.order);
    else
      [Idx,cIdx]=fc_hypermesh.VerticesIdxHypRef(self.m,self.order);
    end
    I=unique(reshape(self.me(Idx,:),[],1));
    pih=fc_tools.graphics.SetHoldOn(true);
    h1=scatter(self.q(1,I),self.q(2,I),vSize,vColor,'filled',PlotOptions{:});
    I=unique(reshape(self.me(cIdx,:),[],1));
    h2=scatter(self.q(1,I),self.q(2,I),nSize,nColor,'filled',PlotOptions{:});
    fc_tools.graphics.RestoreHold(pih)
    h={h1,h2};
  end
end

function h=plotnodes1D(self,vColor,vSize,nColor,nSize,PlotOptions)
  if self.order==1
    h=scatter(self.q(1,:),zeros(1,size(self.q,2)),vSize,vColor,'filled',PlotOptions{:});
  else
    if self.type==0
      [Idx,cIdx]=fc_hypermesh.VerticesIdxSimpRef(self.m,self.order);
    else
      [Idx,cIdx]=fc_hypermesh.VerticesIdxHypRef(self.m,self.order);
    end
    I=unique(reshape(self.me(Idx,:),[],1));
    pih=fc_tools.graphics.SetHoldOn(true);
    h1=scatter(self.q(1,I),zeros(1,length(I)),vSize,vColor,'filled',PlotOptions{:});
    I=unique(reshape(self.me(cIdx,:),[],1));
    h2=scatter(self.q(1,I),zeros(1,length(I)),nSize,nColor,'filled',PlotOptions{:});
    fc_tools.graphics.RestoreHold(pih)
    h={h1,h2};
  end
end
