function varargout=feval2D02(varargin)
  fprintf('************************************\n')
  fprintf('  Running %s function\n',mfilename())
  fprintf('************************************\n')
  [Th,verbose]=fc_simesh.demos.setMesh2D(varargin{:});
  
  
  f=@(x,y) cos(2*x).*sin(3*y);

  g1=@(x,y) g(x,y,2,3);
  g2=@(q) g(q(1,:),q(2,:),2,3);
  
  if verbose,fprintf('*** Computing functions on mesh\n');end
  z=Th.feval(f);
  z1=Th.feval(g1);
  z2=Th.feval(g2);

  
  if verbose,fprintf('*** Check results\n');end
  res=0;
  res=res+ ~( (size(z1,1)==Th.nq) && (size(z2,1)==Th.nq) && (size(z,1)==Th.nq) );
  if verbose, if (res==1),    fprintf('  Test 0: failed with dimensions\n');else fprintf('  Test 0: OK\n');end;end
  E=max(abs(z1-z));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 1: failed with E=%g\n',E);else fprintf('  Test 1: OK\n');end;end
  E=max(abs(z2-z));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 2: failed with E=%g\n',E);else fprintf('  Test 2: OK\n');end;end
  if res>0,error('demo % failed',mfilename()');end
  if nargout==1,varargout{1}=(res==0);end
end

function z=g(x,y,cx,cy)
  z=cos(cx*x).*sin(cy*y);
end
  
